/*
 * Created on 10.02.2005 by HS
 * 
 */
package de.laliluna.relations.one2many.ejb;

import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Iterator;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.RemoveException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import de.laliluna.relations.one2many.interfaces.FingerLocal;
import de.laliluna.relations.one2many.interfaces.FingerLocalHome;
import de.laliluna.relations.one2many.interfaces.FishLocal;
import de.laliluna.relations.one2many.interfaces.FishLocalHome;

/**
 * XDoclet-based session bean.  The class must be declared
 * public according to the EJB specification.
 *
 * To generate the EJB related files to this EJB:
 *		- Add Standard EJB module to XDoclet project properties
 *		- Customize XDoclet configuration for your appserver
 *		- Run XDoclet
 *
 * Below are the xdoclet-related tags needed for this EJB.
 * 
 * @ejb.bean name="TestFishFingers"
 *           display-name="Name for TestFishFingers"
 *           description="Description for TestFishFingers"
 *           jndi-name="ejb/TestFishFingers"
 *           type="Stateless"
 *           view-type="remote"
 */
public class TestFishFingers implements SessionBean {

  /** The session context */
  private SessionContext context;

  /**
   * 
   */
  public TestFishFingers() {
    super();
    // :TODO: Auto-generated constructor stub
  }

  /**
   * Set the associated session context. The container calls this method 
   * after the instance creation.
   * 
   * The enterprise bean instance should store the reference to the context 
   * object in an instance variable.
   * 
   * This method is called with no transaction context. 
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void setSessionContext(SessionContext newContext) throws EJBException {
    context = newContext;
  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbRemove()
   */
  public void ejbRemove() throws EJBException, RemoteException {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbActivate()
   */
  public void ejbActivate() throws EJBException, RemoteException {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbPassivate()
   */
  public void ejbPassivate() throws EJBException, RemoteException {
    // :TODO: Auto-generated method stub

  }

  /**
   * create relations between fish and finger
   *
   * @ejb.interface-method view-type = "remote"
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   * @throws CreateException
   * @throws NamingException
   */
  public void createRelation1() throws EJBException, RemoteException {

    try {
      InitialContext initialContext = new InitialContext();
      FishLocalHome fishLocalHome;
      FingerLocalHome fingerLocalHome;
      // [laliluna] lookup the localHome interfaces in the JNDI context
      fishLocalHome = (FishLocalHome) initialContext
          .lookup(FishLocalHome.JNDI_NAME);
      fingerLocalHome = (FingerLocalHome) initialContext
          .lookup(FingerLocalHome.JNDI_NAME);
      // [laliluna] create entries in the db
      FishLocal fishLocal = (FishLocal) fishLocalHome.create();
      fishLocal.setName("Funny Fish");
      FingerLocal finger1 = (FingerLocal) fingerLocalHome.create();
      finger1.setName("small finger");
      FingerLocal finger2 = (FingerLocal) fingerLocalHome.create();
      finger2.setName("big finger");

      // [laliluna] create the relation
      finger1.setFish(fishLocal);
      finger2.setFish(fishLocal);

      // [laliluna] see if the fish knows its finger now
      Collection collection = fishLocal.getFingers();
      System.out.println("Fingers of fish " + fishLocal.getId());
      for (Iterator iter = collection.iterator(); iter.hasNext();) {
        FingerLocal finger = (FingerLocal) iter.next();
        System.out.println("ID: " + finger.getId() + " name: "
            + finger.getName());
      }

    } catch (NamingException e) {
      e.printStackTrace();
      throw new EJBException(e);
    } catch (CreateException e) {
      // :TODO: Auto-generated catch block
      e.printStackTrace();
    }

  }

  /**
   * create relations between fish and finger
   *
   * @ejb.interface-method view-type = "remote"
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   * @throws CreateException
   * @throws NamingException
   */
  public void createRelation2() throws EJBException, RemoteException {

    try {
      InitialContext initialContext = new InitialContext();
      FishLocalHome fishLocalHome;
      FingerLocalHome fingerLocalHome;
      // [laliluna] lookup the localHome interfaces in the JNDI context
      fishLocalHome = (FishLocalHome) initialContext
          .lookup(FishLocalHome.JNDI_NAME);
      fingerLocalHome = (FingerLocalHome) initialContext
          .lookup(FingerLocalHome.JNDI_NAME);
      // [laliluna] create entries in the db
      FishLocal fishLocal = (FishLocal) fishLocalHome.create();
      fishLocal.setName("Green Fish");
      FingerLocal finger1 = (FingerLocal) fingerLocalHome.create();
      finger1.setName("blue finger");
      FingerLocal finger2 = (FingerLocal) fingerLocalHome.create();
      finger2.setName("red finger");

      // [laliluna] create the relation
      fishLocal.getFingers().add(finger1);
      fishLocal.getFingers().add(finger2);

      // [laliluna] see if the fingers knows the fish now
      System.out.println(finger1.getFish());
      System.out.println(finger2.getFish());

      // [laliluna] delete a finger
      finger1.remove();

      //    [laliluna] see the remaining finger
      Collection collection = fishLocal.getFingers();
      System.out.println("Fingers of fish " + fishLocal.getId());
      for (Iterator iter = collection.iterator(); iter.hasNext();) {
        FingerLocal finger = (FingerLocal) iter.next();
        System.out.println("ID: " + finger.getId() + " name: "
            + finger.getName());
      }
    } catch (NamingException e) {
      e.printStackTrace();
      throw new EJBException(e);
    } catch (CreateException e) {
      // :TODO: Auto-generated catch block
      e.printStackTrace();
    } catch (EJBException e) {
      // :TODO: Auto-generated catch block
      e.printStackTrace();
    } catch (RemoveException e) {
      // :TODO: Auto-generated catch block
      e.printStackTrace();
    }

  }

  /**
   * create relations between fish and finger
   *
   * @ejb.interface-method view-type = "remote"
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   * @throws CreateException
   * @throws NamingException
   */
  public void createRelation3() throws EJBException, RemoteException {

    try {
      InitialContext initialContext = new InitialContext();
      FishLocalHome fishLocalHome;
      FingerLocalHome fingerLocalHome;
      // [laliluna] lookup the localHome interfaces in the JNDI context
      fishLocalHome = (FishLocalHome) initialContext
          .lookup(FishLocalHome.JNDI_NAME);
      fingerLocalHome = (FingerLocalHome) initialContext
          .lookup(FingerLocalHome.JNDI_NAME);
      // [laliluna] create entries in the db
      FishLocal fishLocal = (FishLocal) fishLocalHome.create();
      fishLocal.setName("Crazy Fish");
      FingerLocal finger1 = (FingerLocal) fingerLocalHome.create();
      finger1.setName("long finger");
      FingerLocal finger2 = (FingerLocal) fingerLocalHome.create();
      finger2.setName("very long finger");

      // [laliluna] create the relation
      finger1.setFish(fishLocal);
      finger2.setFish(fishLocal);

      // [laliluna] remove an item from the collection

      // [laliluna] see if the fish knows its finger now
      Collection collection = fishLocal.getFingers();
      collection.remove(finger2);

      System.out.println("Finger 2 is lonly and the fish is "
          + finger2.getFish());

    } catch (NamingException e) {
      e.printStackTrace();
      throw new EJBException(e);
    } catch (CreateException e) {
      // :TODO: Auto-generated catch block
      e.printStackTrace();
    }

  }
}