/*
 * Created on 15.02.2005 by HS
 * 
 */
package de.laliluna.relations.one2manyUni2.ejb;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.RemoveException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import de.laliluna.relations.one2manyUni2.interfaces.LeafLocal;
import de.laliluna.relations.one2manyUni2.interfaces.LeafLocalHome;
import de.laliluna.relations.one2manyUni2.interfaces.TreeLocal;
import de.laliluna.relations.one2manyUni2.interfaces.TreeLocalHome;

/**
 * XDoclet-based session bean.  The class must be declared
 * public according to the EJB specification.
 *
 * To generate the EJB related files to this EJB:
 *		- Add Standard EJB module to XDoclet project properties
 *		- Customize XDoclet configuration for your appserver
 *		- Run XDoclet
 *
 * Below are the xdoclet-related tags needed for this EJB.
 * 
 * @ejb.bean name="TestTreeLeaf"
 *           display-name="Name for TestTreeLeaf"
 *           description="Description for TestTreeLeaf"
 *           jndi-name="ejb/TestTreeLeaf"
 *           type="Stateless"
 *           view-type="remote"
 */
public class TestTreeLeaf implements SessionBean
{

  /** The session context */
  private SessionContext context;

  /**
   * 
   */
  public TestTreeLeaf()
  {
    super();
    // :TODO: Auto-generated constructor stub
  }

  /**
   * Set the associated session context. The container calls this method 
   * after the instance creation.
   * 
   * The enterprise bean instance should store the reference to the context 
   * object in an instance variable.
   * 
   * This method is called with no transaction context. 
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void setSessionContext(SessionContext newContext) throws EJBException
  {
    context = newContext;
  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbRemove()
   */
  public void ejbRemove() throws EJBException, RemoteException
  {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbActivate()
   */
  public void ejbActivate() throws EJBException, RemoteException
  {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbPassivate()
   */
  public void ejbPassivate() throws EJBException, RemoteException
  {
    // :TODO: Auto-generated method stub

  }

  /**
   * An example business method
   *
   * @ejb.interface-method view-type = "remote"
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void createRelation() throws EJBException
  {
    try {
      InitialContext initialContext = new InitialContext();
      TreeLocalHome treeLocalHome = (TreeLocalHome)initialContext.lookup(TreeLocalHome.JNDI_NAME);
      LeafLocalHome  leafLocalHome = (LeafLocalHome) initialContext.lookup(LeafLocalHome.JNDI_NAME);
      
      TreeLocal treeLocal = treeLocalHome.create();
      treeLocal.setName("Birke");
      
      LeafLocal leafLocal = leafLocalHome.create();
      leafLocal.setName("new leaf");
      treeLocal.getLeafs().add(leafLocal);
      
      /* laliluna
       * add this line to test the  behaviour of a cascade delete = "true" or "false"
       * treeLocal.remove();
       */
      
      
    } catch (NamingException e) {
      e.printStackTrace();
    } catch (CreateException e) {
      e.printStackTrace();
    } catch (EJBException e) {
      e.printStackTrace();
    }
  }

}