/*
 * Created on 24.12.2004 by HS
 * 
 */
package de.laliluna.relations.one2one.ejb;

import java.rmi.RemoteException;
import java.util.logging.Logger;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import de.laliluna.relations.one2one.interfaces.CatLocal;
import de.laliluna.relations.one2one.interfaces.CatLocalHome;
import de.laliluna.relations.one2one.interfaces.HouseLocal;
import de.laliluna.relations.one2one.interfaces.HouseLocalHome;

/**
 * XDoclet-based session bean.  The class must be declared
 * public according to the EJB specification.
 *
 * To generate the EJB related files to this EJB:
 *		- Add Standard EJB module to XDoclet project properties
 *		- Customize XDoclet configuration for your appserver
 *		- Run XDoclet
 *
 * Below are the xdoclet-related tags needed for this EJB.
 * 
 * @ejb.bean name="TestCatHouse"
 *           display-name="Name for TestCatHouse"
 *           description="Description for TestCatHouse"
 *           jndi-name="ejb/TestCatHouse"
 *           type="Stateless"
 *           view-type="remote"
 */
public class TestCatHouse implements SessionBean {

  /** The session context */
  private SessionContext context;

  private Logger log = Logger.getLogger(this.getClass().toString());

  /**
   * 
   */
  public TestCatHouse() {
    super();
    // :TODO: Auto-generated constructor stub
  }

  /**
   * Set the associated session context. The container calls this method 
   * after the instance creation.
   * 
   * The enterprise bean instance should store the reference to the context 
   * object in an instance variable.
   * 
   * This method is called with no transaction context. 
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void setSessionContext(SessionContext newContext) throws EJBException {
    context = newContext;
  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbRemove()
   */
  public void ejbRemove() throws EJBException, RemoteException {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbActivate()
   */
  public void ejbActivate() throws EJBException, RemoteException {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbPassivate()
   */
  public void ejbPassivate() throws EJBException, RemoteException {
    // :TODO: Auto-generated method stub

  }

  /**
   * An example business method
   *
   * @ejb.interface-method view-type = "remote"
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void createRelation() throws EJBException {
    // [laliluna] 24.12.2004 we need a context to lookup the localHome Interfaces
    InitialContext initialContext;
    try {
      initialContext = new InitialContext();
      CatLocalHome catLocalHome;
      /*
       * [laliluna] 
       * we use local interfaces, so there is not need to use
       * PortableRemoteObject.narrow
       */
      catLocalHome = (CatLocalHome) initialContext
          .lookup(CatLocalHome.JNDI_NAME);
      HouseLocalHome houseLocalHome;
      houseLocalHome = (HouseLocalHome) initialContext.lookup(HouseLocalHome.JNDI_NAME);
      
      
      CatLocal catLocal = catLocalHome.create();
      catLocal.setName("Pete");
      HouseLocal houseLocal  = houseLocalHome.create();
      houseLocal.setColor("blue");
      
      // [laliluna] now set the relation
      houseLocal.setCat(catLocal);
      
    } catch (NamingException e) {
      throw new EJBException(e);
    } catch (CreateException e) {
      throw new EJBException(e);
    }
  }
}